unit testform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

//--------------------------------------
//   DLL Imported function declaration

function Init(Device : Byte):bool;cdecl; external 'SIMPLELEDWIZ.DLL';
function SBA(Device,b0,b1,b2,b3,pulse : Byte ):boolean;cdecl;external 'SIMPLELEDWIZ.DLL';
function PBA(Device,b0,b1,b2,b3,
				   b4,b5,b6,b7,
				   b8,b9,bA,bB,
				   bC,bD,bE,bF,
				   b10,b11,b12,b13,
				   b14,b15,b16,b17,
				   b18,b19,b1A,b1B,
				   b1C,b1D,b1E,b1F : Byte):boolean;cdecl;external 'SIMPLELEDWIZ.DLL';

procedure FreeAll;cdecl;external 'SIMPLELEDWIZ.DLL';
procedure SetDelay(nDelay : integer );cdecl;external 'SIMPLELEDWIZ.DLL';
//-------------------------------------


type
  TForm1 = class(TForm)
    ButtonInit: TButton;
    ButtonLedOn: TButton;
    ButtonLedOff: TButton;
    ButtonFade: TButton;
    ListBox1: TListBox;
    procedure ButtonInitClick(Sender: TObject);
    procedure ButtonLedOnClick(Sender: TObject);
    procedure ButtonLedOffClick(Sender: TObject);
    procedure ButtonFadeClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    m_bLedWizInitOk : boolean;
    procedure ResetDefaultPBA();
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure TForm1.ResetDefaultPBA;
var
  i, pbaval : integer;
begin
  pbaval:=48;
  for i:=1 to 16 do
  begin
     PBA(i,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval);
  end;

end;

procedure TForm1.ButtonInitClick(Sender: TObject);
var
  i : integer;
begin
  ListBox1.Clear;
  m_bLedWizInitOk:=false;

  //Try to init all LED-Wiz
  for i:=1 to 16 do
  begin
      if Init(i) then
      begin
        //LED-Wiz is found and Initialised
        ListBox1.Items.Add('LED-WIZ'+inttostr(i)+' Found!');
        m_bLedWizInitOk:=true;
      end
      else ListBox1.Items.Add('LED-WIZ'+inttostr(i)+' Not Found!');

  end;
  if  m_bLedWizInitOk then
  begin
      //If at least one LED-Wiz has been found , we enable buttons
      ButtonLedoff.Enabled:=true;
      ButtonLedon.Enabled:=true;
      Buttonfade.Enabled:=true;
      ButtonInit.Enabled:=false;
      //Reset intensity profile to 48 , to be sure to see the led.
      ResetDefaultPBA;
  end;
  SetDelay(10); //Call to this function is optionnal, it is just to speed up the LED-Wiz. The default value (and recommended is 20 (ms))
end;

procedure TForm1.ButtonLedOnClick(Sender: TObject);
var
  i : integer;
begin
  //Browse ALL Led-Wiz  (if a command is sent to a non-initialized LED-Wiz, the command does nothing)
  for i:=1 to 16 do
  begin
      //Highlight all the led for the current LED-Wiz
      SBA(i,255,255,255,255,4);
  end;
end;



procedure TForm1.ButtonLedOffClick(Sender: TObject);
var
  i : integer;
begin
  //Browse ALL Led-Wiz  (if a command is sent to a non-initialized LED-Wiz, the command does nothing)
  for i:=1 to 16 do
  begin
      //Clear all the led for the current LED-Wiz
      SBA(i,0,0,0,0,4);
  end;
end;

procedure TForm1.ButtonFadeClick(Sender: TObject);
var
  i, pbaval : integer;
begin
  //Browse ALL Led-Wiz  (if a command is sent to a non-initialized LED-Wiz, the command does nothing)
  for i:=1 to 16 do
  begin
      //Highlight all the led for the current LED-Wiz
      SBA(i,255,255,255,255,4);
  end;

  //Browse ALL Led-Wiz  (if a command is sent to a non-initialized LED-Wiz, the command does nothing)
  for i:=1 to 16 do
  begin
     //Decrease the PBA Value (Profile of Leds or Intensity of the led)
     for pbaval:=48 downto 0 do
     begin
      //PBA command sent to the LED-Wiz
      PBA(i,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval,pbaval);
     end;
  end;

  //Set State to all led to Off.
  // because PBA=0 does not mean that the led is Off. Just means the intensity is 0.
  ButtonLedOffClick(self);
  //Reset Intensity profile to 48
  ResetDefaultPBA;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //Just to be sure that all led are OFF when we quit.
  ButtonLedOffClick(self);
  FreeAll;
end;

end.
 